import { useState } from "react";
import styles from "./seat.module.css";

function Seat({ onChange, status, seatNo, ...props }) {
  const [show, setShow] = useState(false);
  const handleCheckbox = () => {
    if (status == "available" || status == "selected") {
      onChange({
        id: 1,
        status: status == "available" ? "selected" : "available",
      });
    }
  };

  return (
    <>
      <div
        className={styles.tooltip}
        style={show ? { visibility: "visible" } : {}}
      >
        {seatNo}
        <span className={styles["tooltip-arrow"]} />
      </div>
      <input
        type="checkbox"
        onChange={handleCheckbox}
        className={` ${
          status == "selected"
            ? styles["checkbox-selected"]
            : status == "reserved"
            ? styles["checkbox-reserved"]
            : styles["checkbox-available"]
        }`}
        {...props}
        onMouseEnter={() => setShow(true)}
        onMouseLeave={() => setShow(false)}
      />
    </>
  );
}

export default Seat;
