import { useEffect, useLayoutEffect, useState } from "react";
import SeatLayout from "../components/top-level/seat-layout";
import { useAppContext } from "../_context";
import { useParams } from "react-router-dom";
import { useNavigate } from "react-router-dom";
import { bookingSeats } from "./seed";
export function _Seatlayout({ ...props }) {
  const { userseats, AddOrUpdateSeats, GetAllReservedSeats } = useAppContext();
  const [reservedSeat, setReservedSeat] = useState([]);
  const [selectedSeat, setSelectedSeat] = useState([]);
  const navigate = useNavigate();
  const { id } = useParams();

  useLayoutEffect(() => {
    GetAllReservedSeats();
  }, []);
  useEffect(() => {
    handleReservedSeats();
  }, [userseats]);

  const handleReservedSeats = () => {
    let seatArray = [];
    const reservedSeats = userseats?.filter((e) => e.userId != id);
    reservedSeats.forEach((element) => {
      element.seats.forEach((e) => {
        seatArray = [...seatArray, e];
        setReservedSeat(seatArray);
      });
    });
    const selectedSeats = userseats?.find((e) => e.userId == id);
    const results = selectedSeats?.seats;
    setSelectedSeat(results);
  };

  const handleConfirmed = async ({ userId, seats }) => {
    await AddOrUpdateSeats({ userId, seats });

    const count = seats?.length;
    setTimeout(() => {
      navigate("/confirmation", {
        state: { seatCount: count ?? 0, seats: seats, id },
      });
    }, 500);
  };

  return (
    <SeatLayout
      userId={id}
      seats={bookingSeats}
      selectedSeats={selectedSeat}
      reservedSeats={reservedSeat}
      onClick={handleConfirmed}
      {...props}
    />
  );
}
